
/*
 * exception vector table
 * 
 * 만든사람: sukistyle freestyle, suh1978@gmail.com
 * 개정내용:
 * 참고사항: irq, swi만 구현되어 있다.
 *	      스케줄링은 timer 인터럽트에 의해서만 발생한다.
 */
	
.global do_undefined
do_undefined:	
1:	b 1b

.global do_software_interrupt
do_software_interrupt:
	stmfd	sp!,{r0-r12,lr}
	ldr	r10, [lr, #-4]
	bic	r10, r10, #0xff000000	@ SWI의 인터럽트 번호 계산
	mov	r0, r10
	mrs	r1, spsr
	stmfd	sp!, {r1}
	bl	eventsSWIHandler
	ldmfd	sp!, {r1}
	msr	spsr_cxsf, r1
	ldmfd	sp!, {r0-r12, pc}^

.global do_prefetch_abort
do_prefetch_abort:
1:	b 1b

.global do_data_abort
do_data_abort:
1:	b 1b

.global do_reserved
do_reserved:
1:	b 1b

.global do_IRQ
do_IRQ:
	sub	r14, r14, #4
	
	ldr	r13, =current
	ldr	r13, [r13]

	stmia	r13!, {r0-r14}^		@ r0-r12, sp_usr, lr_usr을 태스크 구조체에 저장

	mrs	r0, spsr
	stmia	r13!, {r0, r14}		@ 유저모드의 cpsr, lr의 벡업데이터인 spsr, r14_irq를 백업

 	ldr	r13, =0x300f9ffc	@ 백업했던 sp_irq를 복원
	
	bl	eventsIRQHandler

	ldr	r13, =current
	ldr	r13, [r13]
 	ldr	r0, [r13, #60]		@ spsr 복원
	msr	spsr, r0
	ldr	r14, [r13, #64]		@ lr 복원
	ldmia	r13!, {r0-r14}^		@ context정보와 함께 cpsr까지 복원

	ldr	r13, =0x300f9ffc	@ sp_irq 복원

	movs	pc, lr
	
.global do_FIQ
do_FIQ:
1:	b 1b
