
#ifndef _RTC_H
#define _RTC_H

#include "interrupt.h"

#define rRTCCON		*(volatile unsigned char *) 0x57000040
#define rBCDSEC		*(volatile unsigned char *) 0x57000070
#define rBCDMIN		*(volatile unsigned char *) 0x57000074
#define rBCDHOUR	*(volatile unsigned char *) 0x57000078
#define rBCDDATE	*(volatile unsigned char *) 0x5700007c
#define rBCDDAY		*(volatile unsigned char *) 0x57000080
#define rBCDMON		*(volatile unsigned char *) 0x57000084
#define rBCDYEAR	*(volatile unsigned char *) 0x57000088

#define rTICNT		*(volatile unsigned char *) 0x57000044


#define RTCEN		0x1	/* RTC control enable		*/
#define TICK_INT_ENABLE	0x80	/* Tick time interrupt enable	*/
#define TICK_TIME_COUNT	0x7f	/* Tick time count value	*/

void rtc_init();
void rtc_close();

void rtc_get();
void rtc_set();
    
#endif
