
/*
 * IRQ 핸들러 
 * 
 * 만든사람: sukistyle freestyle, suh1978@gmail.com
 * 개정내용:
 * 참고사항: 
 */

#include "tcb.h"
#include "timer.h"
#include "printk.h"
#include "schedule.h"
#include "interrupt.h"
#include "system.h"
#include "rtc.h"

extern tcb *current;

void do_irq_timer0();

void eventsIRQHandler()
{
    unsigned int INTOPND;
    unsigned int INTOFFSET;

    INTOPND = rINTPND;
    INTOFFSET = rINTOFFSET;

    rSRCPND |= INTOPND;
    rINTPND |= INTOPND;

    switch (INTOFFSET) {

    case INT_TICK:		/* offset: 8 */
	break;
	
    case TIMER0:		/* offset: 10 */
	do_irq_timer0();
	break;

    case INT_RTC:		/* offset: 30 */
	break;
	
    default:
	printk("unknown interrupt offset......\n");
	break;
    }

    /*
     * 필요하다면 스케줄링을 수행한다
     */
    if (current->need_resched == 1) {
	current->need_resched = 0;
	schedule();
    }
}

void do_irq_timer0()
{
    static unsigned int jiffes = 0;

    jiffes++;

    current->time_remain--;
    if (current->time_remain <= 0) {
	current->time_remain = current->time_slice;
	current->need_resched = 1;
    }
}
