
#include "tcb.h"
#include "rtc.h"
#include "timer.h"
#include "system.h"
#include "printk.h"
#include "string.h"
#include "syscall.h"
#include "interrupt.h"

void kmain(void)
{
    interrupt_init();		/* 모든 인터럽트 mask, 초기화		*/

    uart_init();		/* UART0 초기화				*/
    printk("UART0 init.....................[OK]\n");

    rtc_init();			/* RTC 초기화					*/
    printk("RTC init.......................[OK]\n");

    timer_init();		/* 타이머0 초기화				*/
    printk("TIMER0 init....................[OK]\n");

    
    printk("theBlueOS have booted..........[OK]\n\n");
    
    task_init();		/* task들을 관리하는 TCB 초기화		*/
    task_enroll("BlueSHELL", 5, 2);

    printk("\n");
    
    if (run_task(0)) {		/* runt task0 (idle task)			*/
	printk("idle task run failed!\n");
	while (1)
	    ;
    }

    while(1)			/* 정상이라면 이곳으로 오지 않는다.		*/
	;
}
