
/*
 * 문자열 관련 함수 라이브러리
 * 
 * 만든사람: sukistyle freestyle, suh1978@gmail.com
 * 개정내용:
 * 참고사항: 이 곳에 있는 함수들은 적절한 시점에 라이브러리로 관리될것이다
 */

#include "string.h"

#define isdigit(a)	((a) >= '0' && (a) <= '9')

/*
 * ascii to integer 함수이다
 *
 * 리턴값이 -1이면 문자열에 숫자가 아닌 데이터가 있기 때문이다
 */
int atoi(const char *nptr)
{
    int temp, i, minus;
    unsigned char c;

    i = 0;
    temp = 0;
    minus = 1;

    if (nptr[0] == '-') {
	minus = -1;
	i = 1;
    }

    while ((c = nptr[i++]) != '\0') {
	if (!isdigit(c))
	    return -1;
	
	temp += (temp * 10) + c - '0';
    }
    temp = temp * minus;

    return temp;
}

void strcat(char s[], const char t[])
{
    int i, j;

    i = j = 0;
    while (s[i] != '\0')
	++i;
    
    while ((s[i] = t[j]) != '\0') {
	++i;
	++j;
    }
}

int strcpy(char s[], const char t[])
{
    int i;

    i = 0;
    while ((s[i] = t[i]) != '\0')
	++i;

    return i;
}

int strlen(const char s[])
{
    int i;

    i = 0;
    while (s[i] != '\0')
	++i;

    return i;
}
